﻿using System;
using System.Collections;
using System.Collections.Generic;
using Telerik.Windows.Controls;
using System.IO;
using System.Linq;
using Telerik.Windows.Data;
using System.Windows;
using Telerik.Windows.Documents.FormatProviders;
using Telerik.Windows.Documents.Model;
using Telerik.Windows.Documents.FormatProviders.Pdf;
using System.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using System.Text;


namespace RadGridView_GroupDescriptor
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            string extension = "xls";
            string selectedItem = "Excel";
            ExportFormat format = ExportFormat.Html;

            SaveFileDialog dialog = new SaveFileDialog();
            dialog.DefaultExt = extension;
            dialog.Filter = String.Format("{1} files (*.{0})|*.{0}|All files (*.*)|*.*", extension, selectedItem);
            dialog.FilterIndex = 1;

            if (dialog.ShowDialog() == true)
            {
                using (Stream stream = dialog.OpenFile())
                {
                    GridViewExportOptions options = new GridViewExportOptions();
                    options.Format = format;
                    options.ShowColumnHeaders = true;
                    options.Encoding = Encoding.UTF8;
                    clubsGrid.Export(stream, options);
                }
            }
        }

        private void clubsGrid_ElementExporting(object sender, GridViewElementExportingEventArgs e)
        {
            if (e.Element == ExportElement.HeaderRow)
            {
                e.FontWeight = FontWeights.Bold;
            }
        }

        private void clubsGrid_ElementExported(object sender, GridViewElementExportedEventArgs e)
        {
            if (e.Element == ExportElement.Row)
            {
                // option 1, uncomment instead of option 2 
                //Club obj = e.Context as Club;
                //if (obj != null)
                //{

                //    e.Writer.Write(String.Format(@"<tr><td style=""background-color:#CCC;"" colspan=""{0}"">",
                //        ((IEnumerable<Telerik.Windows.Controls.GridViewColumn>)clubsGrid.Columns).Count()));
                //    foreach (Player player in obj.Players)
                //    {
                //        e.Writer.Write(String.Format(@"<b>Player name:</b> {0} <br />", player.Name));
                //        e.Writer.Write(String.Format(@"<b>Player number:</b> {0} <br />", player.Number));
                //        e.Writer.Write(String.Format(@"<b>Player country:</b> {0} <br />", player.Country));
                //        e.Writer.Write(String.Format(@"<b>Player position:</b> {0} <br />", player.Position));
                //    }
                //    e.Writer.Write("</td></tr>");
                //}

                // option 2
                var template = this.LayoutRoot.Resources["RowDetailsTemplate"] as DataTemplate;
                var grid = template.LoadContent() as RadGridView;
                grid.DataContext = e.Context;
                var subExport = grid.ToHtml();
                e.Writer.Write(subExport);
            }
        }
    }
}
